diff -uNr fwbuilder-2.1.8/src/gui/pixAdvancedDialog.cpp fwbuilder-2.1.9/src/gui/pixAdvancedDialog.cpp
--- fwbuilder-2.1.8/src/gui/pixAdvancedDialog.cpp	2006-10-21 08:35:12.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/pixAdvancedDialog.cpp	2007-01-06 23:03:25.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: pixAdvancedDialog.cpp,v 1.29 2006/10/21 06:35:12 vkurland Exp $
+  $Id: pixAdvancedDialog.cpp,v 1.30 2007/01/06 22:03:25 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -781,7 +781,8 @@
 
 void pixAdvancedDialog::editProlog()
 {
-    SimpleTextEditor edt( pix_prolog_script->text(),
+    SimpleTextEditor edt(this,
+                         pix_prolog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         pix_prolog_script->setText( edt.text() );
@@ -789,7 +790,8 @@
 
 void pixAdvancedDialog::editEpilog()
 {
-    SimpleTextEditor edt( pix_epilog_script->text(),
+    SimpleTextEditor edt(this,
+                         pix_epilog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         pix_epilog_script->setText( edt.text() );
diff -uNr fwbuilder-2.1.8/src/gui/PrefsDialog.cpp fwbuilder-2.1.9/src/gui/PrefsDialog.cpp
--- fwbuilder-2.1.8/src/gui/PrefsDialog.cpp	2006-10-22 06:39:36.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/PrefsDialog.cpp	2007-02-04 05:20:26.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: PrefsDialog.cpp,v 1.28 2006/10/22 04:39:36 vkurland Exp $
+  $Id: PrefsDialog.cpp,v 1.29 2007/02/04 04:20:26 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -262,11 +262,14 @@
 
                 i->load = !i->load;
 
+#if 0
+// commented out for bug #1620284
                 if (i->load)
                 {
                     mw->loadLibrary( i->path.latin1() );
                     om->loadObjects();
                 }
+#endif
                 break;
             }
         }
@@ -301,8 +304,10 @@
         }
         itm->setPixmap(1, pm);
 
-        mw->loadLibrary( i->path.latin1() );
-        om->loadObjects();
+        // commented out for bug #1620284
+        //
+        //mw->loadLibrary( i->path.latin1() );
+        //om->loadObjects();
     }
 }
 
diff -uNr fwbuilder-2.1.8/src/gui/ruleoptionsdialog_q.ui fwbuilder-2.1.9/src/gui/ruleoptionsdialog_q.ui
--- fwbuilder-2.1.8/src/gui/ruleoptionsdialog_q.ui	2006-09-17 20:58:13.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/ruleoptionsdialog_q.ui	2007-01-07 01:36:45.000000000 +0100
@@ -2169,7 +2169,7 @@
     </connection>
     <connection>
         <sender>ipt_logPrefix</sender>
-        <signal>selectionChanged()</signal>
+        <signal>textChanged(const QString&amp;)</signal>
         <receiver>RuleOptionsDialog_q</receiver>
         <slot>changed()</slot>
     </connection>
diff -uNr fwbuilder-2.1.8/src/gui/RuleSetView.cpp fwbuilder-2.1.9/src/gui/RuleSetView.cpp
--- fwbuilder-2.1.8/src/gui/RuleSetView.cpp	2006-10-29 00:53:50.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/RuleSetView.cpp	2007-01-08 16:24:53.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: RuleSetView.cpp,v 1.155 2006/10/28 22:53:50 vkurland Exp $
+  $Id: RuleSetView.cpp,v 1.157 2007/01/08 15:24:53 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -1816,10 +1816,14 @@
     {
         PolicyRule *rule = PolicyRule::cast( ruleIndex[currentRow()] );
         PolicyRule::Action old_act=rule->getAction();
+        RuleSet *subset = NULL;
+        if (old_act==PolicyRule::Branch)
+            subset = rule->getBranch();
+
         if (act!=old_act)
         {
             if (old_act==PolicyRule::Branch)
-                mw->removePolicyBranchTab(rule);
+                mw->removePolicyBranchTab( subset );
 
             rule->setAction( act );
             if (!changingRules)
@@ -1900,6 +1904,7 @@
     if (fwbdebug) qDebug("Firewall changed: changeActionToRoute"); 
     changeAction( PolicyRule::Route );
 }
+
 void RuleSetView::changeActionToBranch()
 {
     if (!isTreeReadWrite(this,ruleset)) return;
@@ -1909,27 +1914,33 @@
         if (fwbdebug) qDebug("Firewall action: changeActionToBranch"); 
         changeAction( PolicyRule::Branch );
 
-        PolicyRule *rule = PolicyRule::cast( ruleIndex[currentRow()] );
-        FWOptions *ropt = rule->getOptionsObject();
+        addRuleBranch( PolicyRule::cast( ruleIndex[currentRow()] ) );
+    }
+}
 
-        QString branchName = ropt->getStr("branch_name").c_str();
-        if (branchName.isEmpty())
-        {
-            QString bn = QString("rule%1_branch").arg(rule->getPosition());
-            ropt->setStr("branch_name",bn.ascii());
-        }
-        RuleSet *subset = rule->getBranch();
-        if (subset==NULL)
-        {
-            // can change action only for the policy rule, therefore
-            // branch can only be a Policy (i.e. can not be NAT)
-            subset = new Policy();
-            rule->add(subset);
-        }
-        mw->addPolicyBranchTab(rule);
+void RuleSetView::addRuleBranch(PolicyRule *rule)
+{
+    if (fwbdebug) qDebug("RuleSetView::addRuleBranch"); 
+
+    FWOptions *ropt = rule->getOptionsObject();
+    QString branchName = ropt->getStr("branch_name").c_str();
+    if (branchName.isEmpty())
+    {
+        QString bn = QString("rule%1_branch").arg(rule->getPosition());
+        ropt->setStr("branch_name",bn.ascii());
     }
+    RuleSet *subset = rule->getBranch();
+    if (subset==NULL)
+    {
+        // can change action only for the policy rule, therefore
+        // branch can only be a Policy (i.e. can not be NAT)
+        subset = new Policy();
+        rule->add(subset);
+    }
+    mw->addPolicyBranchTab(subset);
 }
 
+
 void RuleSetView::changeDitection(PolicyRule::Direction dir)
 {
     if (!isTreeReadWrite(this,ruleset)) return;
@@ -2674,8 +2685,24 @@
         for (int rn=lastSelectedRule; rn>=firstSelectedRule; --rn)
         {
             if (oe->isVisible() && oe->getOpened()==ruleIndex[rn]) oe->close();
+
+            bool delete_branch_tab = false;
+            PolicyRule *r = PolicyRule::cast( ruleIndex[rn] );
+            RuleSet *subset = NULL;
+            if (r)
+            {
+                if (r->getAction()==PolicyRule::Branch)
+                {
+                    subset = r->getBranch();
+                    delete_branch_tab = true;
+                }
+            }
+
             if ( ruleset->deleteRule(rn) )
             {
+                if (delete_branch_tab)
+                    mw->removePolicyBranchTab( subset );
+
                 int lastN=ruleIndex.size()-1;
                 ruleIndex.erase(rn);
 
@@ -2781,11 +2808,13 @@
         qDebug(QString("RuleSetView::insertRule: r->direction=%1")
                .arg(PolicyRule::cast(r)->getDirectionAsString().c_str()));
 
-    if (Policy::cast(ruleset) || InterfacePolicy::cast(ruleset))
+    PolicyRule *newrule_as_policy_rule = PolicyRule::cast(newrule);
+
+    if (newrule_as_policy_rule)
     {
-        PolicyRule::cast(newrule)->setLogging(supports_logging);
-        PolicyRule::cast(newrule)->setAction(PolicyRule::Deny);
-        PolicyRule::cast(newrule)->setDirection(PolicyRule::Both);
+        newrule_as_policy_rule->setLogging(supports_logging);
+        newrule_as_policy_rule->setAction(PolicyRule::Deny);
+        newrule_as_policy_rule->setDirection(PolicyRule::Both);
     }
 
     if (r!=NULL)  copyRuleContent(newrule,Rule::cast(r));
@@ -2803,6 +2832,10 @@
     for (int i=ruleIndex.size(); i>=pos; --i)
         setRuleNumber(i, Rule::cast(ruleIndex[i]));
 
+    if (newrule_as_policy_rule!=NULL &&
+        newrule_as_policy_rule->getAction()==PolicyRule::Branch )
+        addRuleBranch( newrule_as_policy_rule );
+
     dirtyRows[pos]=1;
 ////    adjustRow(pos);
 
diff -uNr fwbuilder-2.1.8/src/gui/RuleSetView.h fwbuilder-2.1.9/src/gui/RuleSetView.h
--- fwbuilder-2.1.8/src/gui/RuleSetView.h	2006-08-30 08:39:37.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/RuleSetView.h	2007-01-06 22:35:05.000000000 +0100
@@ -202,6 +202,8 @@
     virtual void adjustRow( int row );
     virtual void adjustColumn( int col );
 
+    void addRuleBranch(libfwbuilder::PolicyRule *rule);
+    
     bool isDirection (int col);
     bool isAction    (int col);
     bool isOptions   (int col);
diff -uNr fwbuilder-2.1.8/src/gui/SimpleTextEditor.cpp fwbuilder-2.1.9/src/gui/SimpleTextEditor.cpp
--- fwbuilder-2.1.8/src/gui/SimpleTextEditor.cpp	2004-06-02 08:40:52.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/SimpleTextEditor.cpp	2007-01-07 02:00:30.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: SimpleTextEditor.cpp,v 1.4 2004/06/02 06:40:52 vkurland Exp $
+  $Id: SimpleTextEditor.cpp,v 1.6 2007/01/07 01:00:30 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -40,9 +40,10 @@
 
 using namespace std;
 
-SimpleTextEditor::SimpleTextEditor(const QString &txt,
+SimpleTextEditor::SimpleTextEditor(QWidget *parent,
+                                   const QString &txt,
                                    bool enableLoadFromFile,
-                                   const QString &title)
+                                   const QString &title) : SimpleTextEditor_q(parent)
 {
     if (enableLoadFromFile) inputFromFileButton->show();
     else                    inputFromFileButton->hide();
@@ -67,7 +68,7 @@
     {
         QString filename = QFileDialog::getOpenFileName( st->getWDir(),
                                                          NULL,  this, NULL,
-                                                         tr("Choose file that contains PIX commands") );
+                                                         tr("Choose file") );
         if (filename!="")
         {
            ifstream ifile(filename.latin1());
@@ -80,6 +81,7 @@
                return;
            }
 
+           editor->clear();
            char buf[1024];
            while (ifile.getline(buf,1024))
            {
diff -uNr fwbuilder-2.1.8/src/gui/SimpleTextEditor.h fwbuilder-2.1.9/src/gui/SimpleTextEditor.h
--- fwbuilder-2.1.8/src/gui/SimpleTextEditor.h	2004-06-02 08:40:52.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/SimpleTextEditor.h	2007-01-06 23:03:25.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: SimpleTextEditor.h,v 1.3 2004/06/02 06:40:52 vkurland Exp $
+  $Id: SimpleTextEditor.h,v 1.4 2007/01/06 22:03:25 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -35,7 +35,8 @@
 
  public:
 
-    SimpleTextEditor(const QString &txt,
+    SimpleTextEditor(QWidget *parent,
+                     const QString &txt,
                      bool enableLoadFromFile=true,
                      const QString &title="");
 
diff -uNr fwbuilder-2.1.8/src/gui/simpletexteditor_q.ui fwbuilder-2.1.9/src/gui/simpletexteditor_q.ui
--- fwbuilder-2.1.8/src/gui/simpletexteditor_q.ui	2006-10-24 06:05:58.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/simpletexteditor_q.ui	2007-01-06 22:44:49.000000000 +0100
@@ -18,6 +18,9 @@
     <property name="caption">
         <string>Script Editor</string>
     </property>
+    <property name="focusPolicy">
+        <enum>StrongFocus</enum>
+    </property>
     <grid>
         <property name="name">
             <cstring>unnamed</cstring>
diff -uNr fwbuilder-2.1.8/src/gui/simpletextview_q.ui fwbuilder-2.1.9/src/gui/simpletextview_q.ui
--- fwbuilder-2.1.8/src/gui/simpletextview_q.ui	2006-06-14 07:16:45.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/simpletextview_q.ui	2007-01-06 22:44:49.000000000 +0100
@@ -15,6 +15,9 @@
     <property name="caption">
         <string>Text viewer</string>
     </property>
+    <property name="focusPolicy">
+        <enum>StrongFocus</enum>
+    </property>
     <vbox>
         <property name="name">
             <cstring>unnamed</cstring>
@@ -46,7 +49,6 @@
                     </property>
                     <property name="font">
                         <font>
-                            <pointsize>14</pointsize>
                             <bold>1</bold>
                         </font>
                     </property>
diff -uNr fwbuilder-2.1.8/src/gui/SSHUnx.cpp fwbuilder-2.1.9/src/gui/SSHUnx.cpp
--- fwbuilder-2.1.8/src/gui/SSHUnx.cpp	2006-09-17 07:15:50.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/SSHUnx.cpp	2007-01-30 18:01:50.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: SSHUnx.cpp,v 1.18 2006/09/17 05:15:50 vkurland Exp $
+  $Id: SSHUnx.cpp,v 1.19 2007/01/30 17:01:50 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -89,6 +89,9 @@
     {
         if ( stdoutBuffer.findRev(*i,-1)!=-1 )
         {
+            if (fwbdebug)
+                qDebug(QString("SSHUnx::stateMachine: detected an error: '%1'").arg(*i));
+
             emit printStdout_sign( tr("\n*** Fatal error :") );
             emit printStdout_sign( stdoutBuffer+"\n" );
             stdoutBuffer="";
diff -uNr fwbuilder-2.1.8/src/ipt/MangleTableCompiler_ipt.cpp fwbuilder-2.1.9/src/ipt/MangleTableCompiler_ipt.cpp
--- fwbuilder-2.1.8/src/ipt/MangleTableCompiler_ipt.cpp	2006-09-09 07:05:00.000000000 +0200
+++ fwbuilder-2.1.9/src/ipt/MangleTableCompiler_ipt.cpp	2007-01-05 07:47:05.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@vk.crocodile.org
 
-  $Id: MangleTableCompiler_ipt.cpp,v 1.7 2006/09/09 05:05:00 vkurland Exp $
+  $Id: MangleTableCompiler_ipt.cpp,v 1.8 2007/01/05 06:47:05 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -65,13 +65,27 @@
     if (rule->getAction() == PolicyRule::Branch &&
         ruleopt->getBool("ipt_branch_in_mangle"))
     {
-        PolicyRule* r = 
-            PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+        PolicyRule* r;
+
+        // this is a branching rule for mangle table. Need to put it
+        // into PREROUTING and POSTROUTING chains as well because some
+        // targets that work with mangle table can only go into these
+        // chains, yet we do not know what kind of rules will user
+        // place in the branch
+
+        r = PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
         compiler->temp_ruleset->add(r);
         r->duplicate(rule);
         r->setStr("ipt_chain","PREROUTING");
         tmp_queue.push_back(r);
 
+
+        r = PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+        compiler->temp_ruleset->add(r);
+        r->duplicate(rule);
+        r->setStr("ipt_chain","POSTROUTING");
+        tmp_queue.push_back(r);
+
         tmp_queue.push_back(rule);
     }
 
diff -uNr fwbuilder-2.1.8/src/ipt/NATCompiler_ipt.cpp fwbuilder-2.1.9/src/ipt/NATCompiler_ipt.cpp
--- fwbuilder-2.1.8/src/ipt/NATCompiler_ipt.cpp	2006-09-11 02:41:09.000000000 +0200
+++ fwbuilder-2.1.9/src/ipt/NATCompiler_ipt.cpp	2007-01-15 02:21:58.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@vk.crocodile.org
 
-  $Id: NATCompiler_ipt.cpp,v 1.25 2006/09/11 00:41:09 vkurland Exp $
+  $Id: NATCompiler_ipt.cpp,v 1.26 2007/01/15 01:21:58 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -94,8 +94,12 @@
     ostringstream  ostr;
     string name=at->getName();
     string::size_type p1;
-    while ( (p1=name.find(" "))!=string::npos)
-        name=name.replace(p1,1,"_");
+    char *bad_shell_chars = " !#$&*()-+=\\|{}[]?<>,.";
+    for (char *cptr=bad_shell_chars; *cptr; cptr++)
+    {
+        while ( (p1=name.find(*cptr))!=string::npos)
+            name=name.replace(p1,1,"_");
+    }
     ostr << "at_" << name;
     return ostr.str();
 }
diff -uNr fwbuilder-2.1.8/src/ipt/OSConfigurator_linux24.cpp fwbuilder-2.1.9/src/ipt/OSConfigurator_linux24.cpp
--- fwbuilder-2.1.8/src/ipt/OSConfigurator_linux24.cpp	2006-05-17 00:39:59.000000000 +0200
+++ fwbuilder-2.1.9/src/ipt/OSConfigurator_linux24.cpp	2007-01-16 06:26:54.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@vk.crocodile.org
 
-  $Id: OSConfigurator_linux24.cpp,v 1.35 2006/05/16 22:39:59 vkurland Exp $
+  $Id: OSConfigurator_linux24.cpp,v 1.38 2007/01/16 05:26:54 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -425,7 +425,7 @@
     
     output << "check_file() {"                             << endl;
     output << "  test -r \"$2\" || {"                      << endl;
-    output << "    echo \"Can not find file '$2' referenced by AddressTable object '$1'\"" << endl;
+    output << "    echo \"Can not find file $2 referenced by AddressTable object $1\"" << endl;
     output << "    exit 1"                                 << endl;
     output << "  }"                                        << endl;
     output << "}"                                          << endl;
@@ -654,7 +654,7 @@
         p2=command_line.find(" ",p1);
         string at_var= command_line.substr(p1+1,p2-p1-1);  // skip '$'
         string atfile = rule->getStr("address_table_file");
-        ext_command_line << "grep -Ev '^#' " << atfile << " | ";
+        ext_command_line << "grep -Ev '^#|^;|^\\s*$' " << atfile << " | ";
         ext_command_line << "while read L ; do" << endl;
         ext_command_line << "  set $L; " << at_var << "=$1; ";
         ext_command_line << command_line;
